Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm	(revision 34921)
@@ -1911,4 +2821,299 @@
 );
 
+# Picture Control information V2 (ref 28)
+%Image::ExifTool::Nikon::PictureControl2 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    # NOTE: Must set ByteOrder in SubDirectory if any multi-byte integer tags added
+    0 => {
+        Name => 'PictureControlVersion',
+        Format => 'undef[4]',
+        Writable => 0,
+    },
+    4 => {
+        Name => 'PictureControlName',
+        Format => 'string[20]',
+        # make lower case with a leading capital for each word
+        PrintConv => \&FormatString,
+        PrintConvInv => 'uc($val)',
+    },
+    24 => {
+        Name => 'PictureControlBase',
+        Format => 'string[20]',
+        PrintConv => \&FormatString,
+        PrintConvInv => 'uc($val)',
+    },
+    # beginning at byte 44, there is some interesting information.
+    # here are the observed bytes for each PictureControlMode:
+    #            44 45 46 47 48 49 50 51 52 53 54 55 56 57
+    # STANDARD   00 01 00 00 00 80 83 80 80 80 80 ff ff ff
+    # NEUTRAL    03 c2 00 00 00 ff 82 80 80 80 80 ff ff ff
+    # VIVID      00 c3 00 00 00 80 84 80 80 80 80 ff ff ff
+    # MONOCHROME 06 4d 00 01 02 ff 82 80 80 ff ff 80 80 ff
+    # Neutral2   03 c2 01 00 02 ff 80 7f 81 00 7f ff ff ff (custom)
+    # (note that up to 9 different custom picture controls can be stored)
+    # --> bytes 44 and 45 are swapped if CaptureNX changes the byte order
+    #
+    48 => { #21
+        Name => 'PictureControlAdjust',
+        PrintConv => {
+            0 => 'Default Settings',
+            1 => 'Quick Adjust',
+            2 => 'Full Control',
+        },
+    },
+    49 => {
+        Name => 'PictureControlQuickAdjust',
+        # settings: -2 to +2 (n/a for Neutral and Monochrome modes)
+        DelValue => 0xff,
+        ValueConv => '$val - 0x80',
+        ValueConvInv => '$val + 0x80',
+        PrintConv => 'Image::ExifTool::Nikon::PrintPC($val)',
+        PrintConvInv => 'Image::ExifTool::Nikon::PrintPCInv($val)',
+    },
+    51 => {
+        Name => 'Sharpness',
+        DelValue => 0xff,
+        ValueConv => '$val - 0x80',
+        ValueConvInv => '$val + 0x80',
+        PrintConv => 'Image::ExifTool::Nikon::PrintPC($val,"None","%.2f",4)',
+        PrintConvInv => 'Image::ExifTool::Nikon::PrintPCInv($val,4)',
+    },
+    53 => {
+        Name => 'Clarity',
+        DelValue => 0xff,
+        ValueConv => '$val - 0x80',
+        ValueConvInv => '$val + 0x80',
+        PrintConv => 'Image::ExifTool::Nikon::PrintPC($val,"None","%.2f",4)',
+        PrintConvInv => 'Image::ExifTool::Nikon::PrintPCInv2($val,4)',
+    },
+    55 => {
+        Name => 'Contrast',
+        DelValue => 0xff,
+        ValueConv => '$val - 0x80',
+        ValueConvInv => '$val + 0x80',
+        PrintConv => 'Image::ExifTool::Nikon::PrintPC($val,"None","%.2f",4)',
+        PrintConvInv => 'Image::ExifTool::Nikon::PrintPCInv($val,4)',
+    },
+    57 => { #21
+        Name => 'Brightness',
+        # settings: -1 to +1
+        ValueConv => '$val - 0x80',
+        ValueConvInv => '$val + 0x80',
+        PrintConv => 'Image::ExifTool::Nikon::PrintPC($val,undef,"%.2f",4)',
+        PrintConvInv => 'Image::ExifTool::Nikon::PrintPCInv($val,4)',
+    },
+    59 => {
+        Name => 'Saturation',
+        DelValue => 0xff,
+        ValueConv => '$val - 0x80',
+        ValueConvInv => '$val + 0x80',
+        PrintConv => 'Image::ExifTool::Nikon::PrintPC($val,"None","%.2f",4)',
+        PrintConvInv => 'Image::ExifTool::Nikon::PrintPCInv($val,4)',
+    },
+    61 => {
+        Name => 'Hue',
+        DelValue => 0xff,
+        ValueConv => '$val - 0x80',
+        ValueConvInv => '$val + 0x80',
+        PrintConv => 'Image::ExifTool::Nikon::PrintPC($val,"None","%.2f",4)',
+        PrintConvInv => 'Image::ExifTool::Nikon::PrintPCInv($val)',
+    },
+    63 => {
+        Name => 'FilterEffect',
+        # settings: Off,Yellow,Orange,Red,Green (n/a for color modes)
+        DelValue => 0xff,
+        PrintHex => 1,
+        PrintConv => {
+            0x80 => 'Off',
+            0x81 => 'Yellow',
+            0x82 => 'Orange',
+            0x83 => 'Red',
+            0x84 => 'Green',
+            0xff => 'n/a',
+        },
+    },
+    64 => {
+        Name => 'ToningEffect',
+        # settings: B&W,Sepia,Cyanotype,Red,Yellow,Green,Blue-Green,Blue,
+        #           Purple-Blue,Red-Purple (n/a for color modes)
+        DelValue => 0xff,
+        PrintHex => 1,
+        PrintConvColumns => 2,
+        PrintConv => {
+            0x80 => 'B&W',
+            0x81 => 'Sepia',
+            0x82 => 'Cyanotype',
+            0x83 => 'Red',
+            0x84 => 'Yellow',
+            0x85 => 'Green',
+            0x86 => 'Blue-green',
+            0x87 => 'Blue',
+            0x88 => 'Purple-blue',
+            0x89 => 'Red-purple',
+            0xff => 'n/a',
+        },
+    },
+    65 => {
+        Name => 'ToningSaturation',
+        DelValue => 0xff,
+        ValueConv => '$val - 0x80',           #$val == 0x7f (n/a) for "B&W"
+        ValueConvInv => '$val + 0x80',
+        PrintConv => 'Image::ExifTool::Nikon::PrintPC($val,"None","%.2f",4)',
+        PrintConvInv => 'Image::ExifTool::Nikon::PrintPCInv($val,4)',
+
+    },
+);
+
+# Picture Control information V3 (ref PH, Z7)
+%Image::ExifTool::Nikon::PictureControl3 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    # NOTE: Must set ByteOrder in SubDirectory if any multi-byte integer tags added
+    0 => {
+        Name => 'PictureControlVersion',
+        Format => 'undef[4]',
+        Writable => 0,
+    },
+    8 => {
+        Name => 'PictureControlName',
+        Format => 'string[20]',
+        # make lower case with a leading capital for each word
+        PrintConv => \&FormatString,
+        PrintConvInv => 'uc($val)',
+    },
+    # 48 - looks like PictureControl2 byte 45
+    28 => {
+        Name => 'PictureControlBase',
+        Format => 'string[20]',
+        PrintConv => \&FormatString,
+        PrintConvInv => 'uc($val)',
+    },
+    54 => { # (NC)
+        Name => 'PictureControlAdjust',
+        PrintConv => {
+            0 => 'Default Settings',
+            1 => 'Quick Adjust',
+            2 => 'Full Control',
+        },
+    },
+    55 => { # (NC)
+        Name => 'PictureControlQuickAdjust',
+        DelValue => 0xff,
+        ValueConv => '$val - 0x80',
+        ValueConvInv => '$val + 0x80',
+        PrintConv => 'Image::ExifTool::Nikon::PrintPC($val)',
+        PrintConvInv => 'Image::ExifTool::Nikon::PrintPCInv($val)',
+    },
+    57 => {
+        Name => 'Sharpness',
+        DelValue => 0xff,
+        ValueConv => '$val - 0x80',
+        ValueConvInv => '$val + 0x80',
+        PrintConv => 'Image::ExifTool::Nikon::PrintPC($val,"None","%.2f",4)',
+        PrintConvInv => 'Image::ExifTool::Nikon::PrintPCInv($val,4)',
+    },
+    59 => {
+        Name => 'MidRangeSharpness',
+        DelValue => 0xff,
+        ValueConv => '$val - 0x80',
+        ValueConvInv => '$val + 0x80',
+        PrintConv => 'Image::ExifTool::Nikon::PrintPC($val,"None","%.2f",4)',
+        PrintConvInv => 'Image::ExifTool::Nikon::PrintPCInv($val,4)',
+    },
+    61 => {
+        Name => 'Clarity',
+        DelValue => 0xff,
+        ValueConv => '$val - 0x80',
+        ValueConvInv => '$val + 0x80',
+        PrintConv => 'Image::ExifTool::Nikon::PrintPC($val,"None","%.2f",4)',
+        PrintConvInv => 'Image::ExifTool::Nikon::PrintPCInv2($val,4)',
+    },
+    63 => {
+        Name => 'Contrast',
+        DelValue => 0xff,
+        ValueConv => '$val - 0x80',
+        ValueConvInv => '$val + 0x80',
+        PrintConv => 'Image::ExifTool::Nikon::PrintPC($val,"None","%.2f",4)',
+        PrintConvInv => 'Image::ExifTool::Nikon::PrintPCInv($val,4)',
+    },
+    65 => { #21
+        Name => 'Brightness',
+        ValueConv => '$val - 0x80',
+        ValueConvInv => '$val + 0x80',
+        PrintConv => 'Image::ExifTool::Nikon::PrintPC($val,undef,"%.2f",4)',
+        PrintConvInv => 'Image::ExifTool::Nikon::PrintPCInv($val,4)',
+    },
+    67 => {
+        Name => 'Saturation',
+        DelValue => 0xff,
+        ValueConv => '$val - 0x80',
+        ValueConvInv => '$val + 0x80',
+        PrintConv => 'Image::ExifTool::Nikon::PrintPC($val,"None","%.2f",4)',
+        PrintConvInv => 'Image::ExifTool::Nikon::PrintPCInv($val,4)',
+    },
+    69 => {
+        Name => 'Hue',
+        DelValue => 0xff,
+        ValueConv => '$val - 0x80',
+        ValueConvInv => '$val + 0x80',
+        PrintConv => 'Image::ExifTool::Nikon::PrintPC($val,"None","%.2f",4)',
+        PrintConvInv => 'Image::ExifTool::Nikon::PrintPCInv($val)',
+    },
+    71 => { # (NC)
+        Name => 'FilterEffect',
+        DelValue => 0xff,
+        PrintHex => 1,
+        PrintConv => {
+            0x80 => 'Off',
+            0x81 => 'Yellow',
+            0x82 => 'Orange',
+            0x83 => 'Red',
+            0x84 => 'Green',
+            0xff => 'n/a',
+        },
+    },
+    72 => { # (NC)
+        Name => 'ToningEffect',
+        DelValue => 0xff,
+        PrintHex => 1,
+        PrintConvColumns => 2,
+        PrintConv => {
+            0x80 => 'B&W',
+            0x81 => 'Sepia',
+            0x82 => 'Cyanotype',
+            0x83 => 'Red',
+            0x84 => 'Yellow',
+            0x85 => 'Green',
+            0x86 => 'Blue-green',
+            0x87 => 'Blue',
+            0x88 => 'Purple-blue',
+            0x89 => 'Red-purple',
+            0xff => 'n/a',
+        },
+    },
+    73 => { # (NC)
+        Name => 'ToningSaturation',
+        DelValue => 0xff,
+        ValueConv => '$val - 0x80',
+        ValueConvInv => '$val + 0x80',
+        PrintConv => 'Image::ExifTool::Nikon::PrintPC($val,"None","%.2f",4)',
+        PrintConvInv => 'Image::ExifTool::Nikon::PrintPCInv($val,4)',
+
+    },
+);
+
+# Unknown Picture Control information
+%Image::ExifTool::Nikon::PictureControlUnknown = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    # NOTE: Must set ByteOrder in SubDirectory if any multi-byte integer tags added
+    0 => {
+        Name => 'PictureControlVersion',
+        Format => 'undef[4]',
+        Writable => 0,
+    },
+);
+
 # World Time information - JD (D300)
 %Image::ExifTool::Nikon::WorldTime = (
@@ -1916,5 +3121,5 @@
     GROUPS => { 0 => 'MakerNotes', 2 => 'Time' },
     0 => {
-        Name => 'Timezone',
+        Name => 'TimeZone',
         Format => 'int16s',
         PrintConv => q{
@@ -1960,4 +3165,49 @@
     4 => {
         Name => 'ISOExpansion',
+        Format => 'int16u',
+        PrintHex => 1,
+        PrintConvColumns => 2,
+        PrintConv => {
+            0x000 => 'Off',
+            0x101 => 'Hi 0.3',
+            0x102 => 'Hi 0.5',
+            0x103 => 'Hi 0.7',
+            0x104 => 'Hi 1.0',
+            0x105 => 'Hi 1.3', # (Hi 1.3-1.7 may be possible with future models)
+            0x106 => 'Hi 1.5',
+            0x107 => 'Hi 1.7',
+            0x108 => 'Hi 2.0', #(NC) - D3 should have this mode
+            0x109 => 'Hi 2.3', #IB
+            0x10a => 'Hi 2.5', #IB
+            0x10b => 'Hi 2.7', #IB
+            0x10c => 'Hi 3.0', #IB
+            0x10d => 'Hi 3.3', #IB
+            0x10e => 'Hi 3.5', #IB
+            0x10f => 'Hi 3.7', #IB
+            0x110 => 'Hi 4.0', #IB
+            0x111 => 'Hi 4.3', #IB
+            0x112 => 'Hi 4.5', #IB
+            0x113 => 'Hi 4.7', #IB
+            0x114 => 'Hi 5.0', #IB
+            0x201 => 'Lo 0.3',
+            0x202 => 'Lo 0.5',
+            0x203 => 'Lo 0.7',
+            0x204 => 'Lo 1.0',
+        },
+    },
+    # bytes 6-11 same as 0-4 in my samples (why is this duplicated?)
+    6 => {
+        Name => 'ISO2',
+        Notes => 'val = 100 * 2**(raw/12-5)',
+        ValueConv => '100*exp(($val/12-5)*log(2))',
+        ValueConvInv => '(log($val/100)/log(2)+5)*12',
+        PrintConv => 'int($val + 0.5)',
+        PrintConvInv => '$val',
+    },
+    # 7 - 0x01
+    # 8 - 0x0c (probably the ISO divisor above)
+    # 9 - 0x00
+    10 => {
+        Name => 'ISOExpansion2',
         Format => 'int16u',
         PrintHex => 1,
@@ -1979,37 +3229,4 @@
         },
     },
-    # bytes 6-11 same as 0-4 in my samples (why is this duplicated?)
-    6 => {
-        Name => 'ISO2',
-        Notes => 'val = 100 * 2**(raw/12-5)',
-        ValueConv => '100*exp(($val/12-5)*log(2))',
-        ValueConvInv => '(log($val/100)/log(2)+5)*12',
-        PrintConv => 'int($val + 0.5)',
-        PrintConvInv => '$val',
-    },
-    # 7 - 0x01
-    # 8 - 0x0c (probably the ISO divisor above)
-    # 9 - 0x00
-    10 => {
-        Name => 'ISOExpansion2',
-        Format => 'int16u',
-        PrintHex => 1,
-        PrintConvColumns => 2,
-        PrintConv => {
-            0x000 => 'Off',
-            0x101 => 'Hi 0.3',
-            0x102 => 'Hi 0.5',
-            0x103 => 'Hi 0.7',
-            0x104 => 'Hi 1.0',
-            0x105 => 'Hi 1.3', # (Hi 1.3-1.7 may be possible with future models)
-            0x106 => 'Hi 1.5',
-            0x107 => 'Hi 1.7',
-            0x108 => 'Hi 2.0', #(NC) - D3 should have this mode
-            0x201 => 'Lo 0.3',
-            0x202 => 'Lo 0.5',
-            0x203 => 'Lo 0.7',
-            0x204 => 'Lo 1.0',
-        },
-    },
     # bytes 12-13: 00 00
 );
@@ -2019,4 +3236,5 @@
     %binaryDataAttrs,
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    # NOTE: Must set ByteOrder in SubDirectory if any multi-byte integer tags added
     0 => {
         Name => 'DistortionVersion',
@@ -2027,5 +3245,9 @@
     4 => {
         Name => 'AutoDistortionControl',
-        PrintConv => \%offOn,
+        PrintConv => {
+            0 => 'Off',
+            1 => 'On',
+            2 => 'On (underwater)', # (1AW1)
+        },
     },
 );
@@ -2043,4 +3265,5 @@
         Unknown => 1,
     },
+    # (bytes 6/7 and 8/9 are swapped if CaptureNX changes the byte order)
 );
 
@@ -2057,4 +3280,5 @@
         Unknown => 1,
     },
+    # (byte 4 may be changed from 1 to 0 when rewritten by CaptureNX)
 );
 
@@ -2090,4 +3314,5 @@
             9 => 'Far Left',
             10 => 'Far Right',
+            # (have also seen values of 11 and 12 when AFPointsInFocus is "(none)" - PH S3500)
         },
     },
@@ -2097,4 +3322,5 @@
         PrintConvColumns => 2,
         PrintConv => {
+            0 => '(none)',
             0x7ff => 'All 11 Points',
             BITMASK => {
@@ -2119,5 +3345,5 @@
     %binaryDataAttrs,
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
-    DATAMEMBER => [ 4, 6 ],
+    DATAMEMBER => [ 0, 4, 6 ],
     NOTES => "These tags are written by Nikon DSLR's which have the live view feature.",
     # NOTE: Must set ByteOrder in SubDirectory if any multi-byte integer tags added
@@ -2126,9 +3352,14 @@
         Format => 'undef[4]',
         Writable => 0,
+        RawConv => '$$self{AFInfo2Version} = $val',
     },
     4 => { #PH
         Name => 'ContrastDetectAF',
         RawConv => '$$self{ContrastDetectAF} = $val',
-        PrintConv => \%offOn,
+        PrintConv => {
+            %offOn,
+            2 => 'On (2)', #PH (Z7)
+        },
+        Notes => 'this is Off for the hybrid AF used in Nikon 1 models',
     },
     5 => [
@@ -2151,4 +3382,21 @@
                 11 => 'Dynamic Area (wide)', #PH
                 12 => 'Dynamic Area (wide, 3D-tracking)', #PH
+                13 => 'Group Area', #PH
+                14 => 'Dynamic Area (25 points)', #PH
+                15 => 'Dynamic Area (72 points)', #PH
+                16 => 'Group Area (HL)', #28
+                17 => 'Group Area (VL)', #28
+                18 => 'Dynamic Area (49 points)', #28
+                128 => 'Single', #PH (1J1,1J2,1J3,1J4,1S1,1S2,1V2,1V3)
+                129 => 'Auto (41 points)', #PH (1J1,1J2,1J3,1J4,1S1,1S2,1V1,1V2,1V3,AW1)
+                130 => 'Subject Tracking (41 points)', #PH (1J1,1J4,1J3)
+                131 => 'Face Priority (41 points)', #PH (1J1,1J3,1S1,1V2,AW1)
+                # 134 - seen for 1V1[PhaseDetectAF=0] (PH)
+                # 135 - seen for 1J2[PhaseDetectAF=4] (PH)
+                192 => 'Pinpoint', #PH (NC)
+                193 => 'Single', #PH (NC)
+                195 => 'Wide (S)', #PH (NC)
+                196 => 'Wide (L)', #PH (NC)
+                197 => 'Auto', #PH (NC)
             },
         },
@@ -2165,4 +3413,20 @@
                 3 => 'Contrast-detect (face priority)', # (ViewNX)
                 4 => 'Contrast-detect (subject tracking)', # (ViewNX)
+                128 => 'Single', #PH (1V3)
+                129 => 'Auto (41 points)', #PH (NC)
+                130 => 'Subject Tracking (41 points)', #PH (NC)
+                131 => 'Face Priority (41 points)', #PH (NC)
+                192 => 'Pinpoint', #PH (Z7)
+                193 => 'Single', #PH (Z7)
+                194 => 'Dynamic', #PH (Z7)
+                195 => 'Wide (S)', #PH (Z7)
+                196 => 'Wide (L)', #PH (Z7)
+                197 => 'Auto', #PH (Z7)
+                198 => 'Auto (People)', #28 (Z7)    #if no faces are detected, will record as 'Auto'.  Camera setting recorded in AFAreaMode field in the MakerNotes area
+                199 => 'Auto (Animal)', #28 (Z7)    #if no animals are detected, will record as 'Auto'.  Camera setting recorded in AFAreaMode field in the MakerNotes area
+                200 => 'Normal-area AF', #28 (D6)
+                201 => 'Wide-area AF', #28 (D6)
+                202 => 'Face-priority AF', #28 (D6)
+                203 => 'Subject-tracking AF', #28 (D6)
             },
         },
@@ -2173,8 +3437,15 @@
         RawConv => '$$self{PhaseDetectAF} = $val',
         PrintConv => {
+            # [observed AFAreaMode values in square brackets for each PhaseDetectAF value]
             0 => 'Off',
             1 => 'On (51-point)', #PH
             2 => 'On (11-point)', #PH
             3 => 'On (39-point)', #29 (D7000)
+            4 => 'On (73-point)', #PH (1J1[128/129],1J2[128/129/135],1J3/1S1/1V2[128/129/131],1V1[129],AW1[129/131])
+            5 => 'On (5)', #PH (1S2[128/129], 1J4/1V3[129])
+            6 => 'On (105-point)', #PH (1J4/1V3[128/130])
+            7 => 'On (153-point)', #PH (D5/D500/D850)
+            8 => 'On (81-point)', #38
+            9 => 'On (105-point)', #28 (D6)
         },
     },
@@ -2182,39 +3453,20 @@
         { #PH/JD
             Name => 'PrimaryAFPoint',
-            Condition => '$$self{PhaseDetectAF} < 2',
-            Notes => 'models with 51-point AF: D3, D3S, D3X, D300, D300S and D700',
+            # PrimaryAFPoint may only be valid for PhaseDetect - certainly true on the D6, possibly other bodies? (ref 28)
+            Condition => '$$self{PhaseDetectAF} < 2 and $$self{AFInfo2Version} ne "0301"',
+            Notes => q{
+                models with 51-point AF -- 5 rows (A-E) and 11 columns (1-11): D3, D3S, D3X,
+                D4, D4S, D300, D300S, D700, D800, D800e and D810
+            },
             PrintConvColumns => 5,
             PrintConv => {
-                0 => '(none)',      26 => 'C10',
-                1 => 'C6 (Center)', 27 => 'B10',
-                2 => 'B6',          28 => 'A9',
-                3 => 'A5',          29 => 'D10',
-                4 => 'D6',          30 => 'E9',
-                5 => 'E5',          31 => 'C11',
-                6 => 'C7',          32 => 'B11',
-                7 => 'B7',          33 => 'D11',
-                8 => 'A6',          34 => 'C4',
-                9 => 'D7',          35 => 'B4',
-                10 => 'E6',         36 => 'A3',
-                11 => 'C5',         37 => 'D4',
-                12 => 'B5',         38 => 'E3',
-                13 => 'A4',         39 => 'C3',
-                14 => 'D5',         40 => 'B3',
-                15 => 'E4',         41 => 'A2',
-                16 => 'C8',         42 => 'D3',
-                17 => 'B8',         43 => 'E2',
-                18 => 'A7',         44 => 'C2',
-                19 => 'D8',         45 => 'B2',
-                20 => 'E7',         46 => 'A1',
-                21 => 'C9',         47 => 'D2',
-                22 => 'B9',         48 => 'E1',
-                23 => 'A8',         49 => 'C1',
-                24 => 'D9',         50 => 'B1',
-                25 => 'E8',         51 => 'D1',
+                0 => '(none)',
+                %afPoints51,
+                1 => 'C6 (Center)', # (add " (Center)" to central point)
             },
         },
         { #10
             Name => 'PrimaryAFPoint',
-            Notes => 'models with 11-point AF: D90, D3000 and D5000',
+            Notes => 'models with 11-point AF: D90, D3000, D3100, D5000 and D5100',
             Condition => '$$self{PhaseDetectAF} == 2',
             PrintConvColumns => 2,
@@ -2237,33 +3489,94 @@
             Name => 'PrimaryAFPoint',
             Condition => '$$self{PhaseDetectAF} == 3',
-            Notes => 'models with 39-point AF: D7000 (not verified)',
+            Notes => 'models with 39-point AF: D600 and D7000',
             PrintConvColumns => 5,
             PrintConv => {
-                0 => '(none)',      22 => 'C10',
-                1 => 'C6 (Center)', 23 => 'B10',
-                2 => 'B6',          24 => 'D10',
-                3 => 'A2',          25 => 'C11',
-                4 => 'D6',          26 => 'B11',
-                5 => 'E2',          27 => 'D11',
-                6 => 'C7',          28 => 'C4',
-                7 => 'B7',          29 => 'B4',
-                8 => 'A3',          30 => 'D4',
-                9 => 'D7',          31 => 'C3',
-                10 => 'E3',         32 => 'B3',
-                11 => 'C5',         33 => 'D3',
-                12 => 'B5',         34 => 'C2',
-                13 => 'A1',         35 => 'B2',
-                14 => 'D5',         36 => 'D2',
-                15 => 'E1',         37 => 'C1',
-                16 => 'C8',         38 => 'B1',
-                17 => 'B8',         39 => 'D1',
-                18 => 'D8',
-                19 => 'C9',
-                20 => 'B9',
-                21 => 'D9',
+                0 => '(none)',
+                %afPoints39,
+                1 => 'C6 (Center)', # (add " (Center)" to central point)
+            },
+        },
+        { #PH
+            Name => 'PrimaryAFPoint',
+            Condition => '$$self{PhaseDetectAF} == 4',
+            Notes => 'Nikon 1 models with older 135-point AF and 73-point phase-detect AF',
+            PrintConvColumns => 5,
+            PrintConv => {
+                0 => '(none)',
+                %afPoints135,
+                1 => 'E8 (Center)', # (add " (Center)" to central point)
+            },
+        },
+        { #PH (NC)
+            Name => 'PrimaryAFPoint',
+            Condition => '$$self{PhaseDetectAF} == 5',
+            Notes => q{
+                Nikon 1 models with newer 135-point AF and 73-point phase-detect AF -- 9
+                rows (B-J) and 15 columns (1-15), inside a grid of 11 rows by 15 columns.
+                The points are numbered sequentially, with F8 at the center
+            },
+            PrintConv => {
+                0 => '(none)',
+                82 => 'F8 (Center)',
+                OTHER => sub {
+                    my ($val, $inv) = @_;
+                    return GetAFPointGrid($val, 15, $inv);
+                },
+            },
+        },
+        { #PH
+            Name => 'PrimaryAFPoint',
+            Condition => '$$self{PhaseDetectAF} == 6',
+            Notes => q{
+                Nikon 1 models with 171-point AF and 105-point phase-detect AF -- 9 rows
+                (B-J) and 19 columns (2-20), inside a grid of 11 rows by 21 columns.  The
+                points are numbered sequentially, with F11 at the center
+            },
+            PrintConv => {
+                0 => '(none)',
+                #22 => 'B2 (Top-left)',
+                #40 => 'B20 (Top-right)',
+                115 => 'F11 (Center)',
+                #190 => 'J2 (Bottom-left)',
+                #208 => 'J20 (Bottom-right)',
+                OTHER => sub {
+                    my ($val, $inv) = @_;
+                    return GetAFPointGrid($val, 21, $inv);
+                },
+            },
+        },
+        { #PH
+            Name => 'PrimaryAFPoint',
+            Condition => '$$self{PhaseDetectAF} == 7 and $$self{AFInfo2Version} eq "0100"',
+            Notes => q{
+                Nikon models with 153-point AF -- 9 rows (A-I) and 17 columns (1-17): D5,
+                D500 and D850
+            },
+            PrintConvColumns => 5,
+            PrintConv => {
+                0 => '(none)',
+                %afPoints153,
+                1 => 'E9 (Center)',
+            },
+        },
+        { #PH (Z7) (NC)
+            Name => 'PrimaryAFPoint',
+            Condition => '$$self{PhaseDetectAF} == 8 and $$self{AFInfo2Version} =~ /^03/',
+            Notes => q{
+                Nikon models with 493-point AF -- 17 rows (A-Q) and 29 columns (1-29), I15
+                at the center
+            },
+            PrintConv => {
+                0 => '(none)',
+                246 => 'I15 (Center)',
+                OTHER => sub {
+                    my ($val, $inv) = @_;
+                    return GetAFPointGrid($val, 29, $inv);
+                },
             },
         },
         {
             Name => 'PrimaryAFPoint',
+            Condition => '$$self{AFInfo2Version} eq "0100"',
             Notes => 'future models?...',
             PrintConv => {
@@ -2276,11 +3589,14 @@
         { #JD/PH
             Name => 'AFPointsUsed',
-            Condition => '$$self{PhaseDetectAF} < 2',
+            Condition => '$$self{PhaseDetectAF} < 2 and $$self{AFInfo2Version} ne "0301"',
             Notes => q{
-                models with 51-point AF -- 5 rows: A1-9, B1-11, C1-11, D1-11, E1-9, center
+                models with 51-point AF -- 5 rows: A1-9, B1-11, C1-11, D1-11, E1-9.  Center
                 point is C6
             },
             Format => 'undef[7]',
-            PrintConv => 'Image::ExifTool::Nikon::PrintAFPointsD3($val)',
+            ValueConv => 'join(" ", unpack("H2"x7, $val))',
+            ValueConvInv => '$val=~tr/ //d; pack("H*",$val)',
+            PrintConv => sub { PrintAFPoints(shift, \%afPoints51); },
+            PrintConvInv => sub { PrintAFPointsInv(shift, \%afPoints51); },
         },
         { #10
@@ -2294,4 +3610,5 @@
             PrintConvColumns => 2,
             PrintConv => {
+                0 => '(none)',
                 0x7ff => 'All 11 Points',
                 BITMASK => {
